/* bookmarks.c generated by valac 0.34.0.42-30929, the Vala compiler
 * generated from bookmarks.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_PATH_ELEMENT (path_element_get_type ())
#define PATH_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_ELEMENT, PathElement))
#define IS_PATH_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_ELEMENT))
#define PATH_ELEMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PATH_ELEMENT, PathElementIface))

typedef struct _PathElement PathElement;
typedef struct _PathElementIface PathElementIface;

#define TYPE_BOOKMARKS (bookmarks_get_type ())
#define BOOKMARKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOKMARKS, Bookmarks))
#define BOOKMARKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOKMARKS, BookmarksClass))
#define IS_BOOKMARKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOKMARKS))
#define IS_BOOKMARKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOKMARKS))
#define BOOKMARKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOKMARKS, BookmarksClass))

typedef struct _Bookmarks Bookmarks;
typedef struct _BookmarksClass BookmarksClass;
typedef struct _BookmarksPrivate BookmarksPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_BOOKMARK (bookmark_get_type ())
#define BOOKMARK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOKMARK, Bookmark))
#define BOOKMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOKMARK, BookmarkClass))
#define IS_BOOKMARK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOKMARK))
#define IS_BOOKMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOKMARK))
#define BOOKMARK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOKMARK, BookmarkClass))

typedef struct _Bookmark Bookmark;
typedef struct _BookmarkClass BookmarkClass;
typedef struct _Block9Data Block9Data;
typedef struct _BookmarkPrivate BookmarkPrivate;
typedef struct _Block10Data Block10Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PathElementIface {
	GTypeInterface parent_iface;
};

struct _Bookmarks {
	GtkMenuButton parent_instance;
	BookmarksPrivate * priv;
};

struct _BookmarksClass {
	GtkMenuButtonClass parent_class;
};

struct _BookmarksPrivate {
	GtkListBox* bookmarks_list_box;
	GtkPopover* bookmarks_popover;
	GtkImage* bookmarks_icon;
	GtkSwitch* bookmarked_switch;
	gchar* current_path;
	gchar* _schema_id;
	GSettings* settings;
	gulong switch_active_handler;
};

struct _Block9Data {
	int _ref_count_;
	Bookmarks* self;
	gchar* bookmark;
	Bookmark* bookmark_row;
	gulong destroy_button_clicked_handler;
};

struct _Bookmark {
	GtkGrid parent_instance;
	BookmarkPrivate * priv;
	GtkButton* destroy_button;
};

struct _BookmarkClass {
	GtkGridClass parent_class;
};

struct _Block10Data {
	int _ref_count_;
	Bookmarks* self;
	gulong bookmarks_changed_handler;
};

struct _BookmarkPrivate {
	gchar* _bookmark_name;
	GtkLabel* bookmark_label;
};


static gpointer bookmarks_parent_class = NULL;
static PathElementIface* bookmarks_path_element_parent_iface = NULL;
static gpointer bookmark_parent_class = NULL;

GType path_element_get_type (void) G_GNUC_CONST;
GType bookmarks_get_type (void) G_GNUC_CONST;
#define BOOKMARKS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BOOKMARKS, BookmarksPrivate))
enum  {
	BOOKMARKS_DUMMY_PROPERTY,
	BOOKMARKS_SCHEMA_ID
};
void bookmarks_set_path (Bookmarks* self, const gchar* path);
static void bookmarks_update_icon_and_switch (Bookmarks* self);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
static void bookmarks_update_switch (Bookmarks* self, gboolean bookmarked);
static void bookmarks_update_bookmarks (Bookmarks* self);
static void __lambda5_ (Bookmarks* self, GtkWidget* widget);
static void ___lambda5__gtk_callback (GtkWidget* widget, gpointer self);
GType bookmark_get_type (void) G_GNUC_CONST;
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
Bookmark* bookmark_new (const gchar* bookmark_name);
Bookmark* bookmark_construct (GType object_type, const gchar* bookmark_name);
static void ____lambda6_ (Block9Data* _data9_);
static void bookmarks_remove_bookmark (Bookmarks* self, const gchar* bookmark_name);
static void _____lambda6__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void ____lambda7_ (Block9Data* _data9_);
static void _____lambda7__gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static void bookmarks_switch_changed_cb (Bookmarks* self);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
void bookmarks_set_bookmarked (Bookmarks* self, gboolean new_state);
static void bookmarks_bookmark_activated_cb (Bookmarks* self, GtkListBoxRow* list_box_row);
const gchar* bookmark_get_bookmark_name (Bookmark* self);
static void _bookmarks_bookmark_activated_cb_gtk_list_box_row_activated (GtkListBox* _sender, GtkListBoxRow* row, gpointer self);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
Bookmarks* bookmarks_new (void);
Bookmarks* bookmarks_construct (GType object_type);
const gchar* bookmarks_get_schema_id (Bookmarks* self);
static void bookmarks_set_schema_id (Bookmarks* self, const gchar* value);
static GObject * bookmarks_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void _bookmarks_switch_changed_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _bookmarks___lambda8_ (Bookmarks* self);
static void __bookmarks___lambda8__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static void _bookmarks___lambda9_ (Block10Data* _data10_);
static void __bookmarks___lambda9__gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static void _bookmarks___lambda10_ (Bookmarks* self);
static void __bookmarks___lambda10__gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static void bookmarks_finalize (GObject* obj);
static void _vala_bookmarks_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_bookmarks_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define BOOKMARK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BOOKMARK, BookmarkPrivate))
enum  {
	BOOKMARK_DUMMY_PROPERTY,
	BOOKMARK_BOOKMARK_NAME
};
static void bookmark_set_bookmark_name (Bookmark* self, const gchar* value);
static GObject * bookmark_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void bookmark_finalize (GObject* obj);
static void _vala_bookmark_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_bookmark_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void bookmarks_set_path (Bookmarks* self, const gchar* path) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 30 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 30 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (path != NULL);
#line 32 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->current_path;
#line 32 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = path;
#line 32 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) != 0) {
#line 202 "bookmarks.c"
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 33 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp2_ = path;
#line 33 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 33 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_free0 (self->priv->current_path);
#line 33 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		self->priv->current_path = _tmp3_;
#line 213 "bookmarks.c"
	}
#line 34 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_update_icon_and_switch (self);
#line 217 "bookmarks.c"
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	for (i = 0; i < stack_length; i++) {
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			return TRUE;
#line 229 "bookmarks.c"
		}
	}
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return FALSE;
#line 234 "bookmarks.c"
}


static void bookmarks_update_icon_and_switch (Bookmarks* self) {
	const gchar* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gboolean _tmp5_ = FALSE;
#line 59 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->current_path;
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = _tmp3_;
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5_ = _vala_string_array_contains (_tmp4_, _vala_array_length (_tmp2_), _tmp0_);
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 61 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (_tmp5_) {
#line 264 "bookmarks.c"
		GtkImage* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp6_ = self->priv->bookmarks_icon;
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		g_object_get (_tmp6_, "icon-name", &_tmp7_, NULL);
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp8_ = _tmp7_;
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp9_ = _tmp8_;
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp10_ = g_strcmp0 (_tmp9_, "starred-symbolic") != 0;
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_free0 (_tmp9_);
#line 63 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		if (_tmp10_) {
#line 284 "bookmarks.c"
			GtkImage* _tmp11_ = NULL;
#line 64 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp11_ = self->priv->bookmarks_icon;
#line 64 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			g_object_set (_tmp11_, "icon-name", "starred-symbolic", NULL);
#line 290 "bookmarks.c"
		}
#line 65 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmarks_update_switch (self, TRUE);
#line 294 "bookmarks.c"
	} else {
		GtkImage* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp12_ = self->priv->bookmarks_icon;
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		g_object_get (_tmp12_, "icon-name", &_tmp13_, NULL);
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp14_ = _tmp13_;
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp15_ = _tmp14_;
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp16_ = g_strcmp0 (_tmp15_, "non-starred-symbolic") != 0;
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_free0 (_tmp15_);
#line 69 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		if (_tmp16_) {
#line 315 "bookmarks.c"
			GtkImage* _tmp17_ = NULL;
#line 70 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp17_ = self->priv->bookmarks_icon;
#line 70 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			g_object_set (_tmp17_, "icon-name", "non-starred-symbolic", NULL);
#line 321 "bookmarks.c"
		}
#line 71 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmarks_update_switch (self, FALSE);
#line 325 "bookmarks.c"
	}
}


static void bookmarks_update_switch (Bookmarks* self, gboolean bookmarked) {
	gulong _tmp0_ = 0UL;
	gboolean _tmp1_ = FALSE;
	GtkSwitch* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GtkSwitch* _tmp5_ = NULL;
	gulong _tmp6_ = 0UL;
	GtkSwitch* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GtkSwitch* _tmp9_ = NULL;
	gulong _tmp10_ = 0UL;
#line 74 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 74 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->switch_active_handler;
#line 74 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_vala_return_if_fail (_tmp0_ != ((gulong) 0), "switch_active_handler != 0");
#line 77 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = bookmarked;
#line 77 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp2_ = self->priv->bookmarked_switch;
#line 77 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 77 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = _tmp3_;
#line 77 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (_tmp1_ == _tmp4_) {
#line 78 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		return;
#line 360 "bookmarks.c"
	}
#line 79 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5_ = self->priv->bookmarked_switch;
#line 79 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp6_ = self->priv->switch_active_handler;
#line 79 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_handler_block (_tmp5_, _tmp6_);
#line 80 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp7_ = self->priv->bookmarked_switch;
#line 80 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp8_ = bookmarked;
#line 80 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_switch_set_active (_tmp7_, _tmp8_);
#line 81 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp9_ = self->priv->bookmarked_switch;
#line 81 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp10_ = self->priv->switch_active_handler;
#line 81 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_handler_unblock (_tmp9_, _tmp10_);
#line 380 "bookmarks.c"
}


static void __lambda5_ (Bookmarks* self, GtkWidget* widget) {
	GtkWidget* _tmp0_ = NULL;
#line 86 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (widget != NULL);
#line 86 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = widget;
#line 86 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_destroy (_tmp0_);
#line 392 "bookmarks.c"
}


static void ___lambda5__gtk_callback (GtkWidget* widget, gpointer self) {
#line 86 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	__lambda5_ ((Bookmarks*) self, widget);
#line 399 "bookmarks.c"
}


static Block9Data* block9_data_ref (Block9Data* _data9_) {
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return _data9_;
#line 408 "bookmarks.c"
}


static void block9_data_unref (void * _userdata_) {
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 417 "bookmarks.c"
		Bookmarks* self;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		self = _data9_->self;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_object_unref0 (_data9_->bookmark_row);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_free0 (_data9_->bookmark);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_object_unref0 (self);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		g_slice_free (Block9Data, _data9_);
#line 429 "bookmarks.c"
	}
}


static void ____lambda6_ (Block9Data* _data9_) {
	Bookmarks* self;
	const gchar* _tmp0_ = NULL;
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = _data9_->self;
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = _data9_->bookmark;
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_remove_bookmark (self, _tmp0_);
#line 443 "bookmarks.c"
}


static void _____lambda6__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	____lambda6_ (self);
#line 450 "bookmarks.c"
}


static void ____lambda7_ (Block9Data* _data9_) {
	Bookmarks* self;
	Bookmark* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
	gulong _tmp2_ = 0UL;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = _data9_->self;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = _data9_->bookmark_row;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = _tmp0_->destroy_button;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp2_ = _data9_->destroy_button_clicked_handler;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_handler_disconnect ((GObject*) _tmp1_, _tmp2_);
#line 469 "bookmarks.c"
}


static void _____lambda7__gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	____lambda7_ (self);
#line 476 "bookmarks.c"
}


static void bookmarks_update_bookmarks (Bookmarks* self) {
	GtkListBox* _tmp0_ = NULL;
	gchar** bookmarks = NULL;
	GSettings* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint bookmarks_length1 = 0;
	gint _bookmarks_size_ = 0;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
#line 84 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 86 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_list_box;
#line 86 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda5__gtk_callback, self);
#line 88 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 88 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 88 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks = _tmp3_;
#line 88 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_length1 = _vala_array_length (_tmp2_);
#line 88 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_bookmarks_size_ = bookmarks_length1;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = bookmarks;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4__length1 = bookmarks_length1;
#line 510 "bookmarks.c"
	{
		gchar** bookmark_collection = NULL;
		gint bookmark_collection_length1 = 0;
		gint _bookmark_collection_size_ = 0;
		gint bookmark_it = 0;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmark_collection = _tmp4_;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmark_collection_length1 = _tmp4__length1;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		for (bookmark_it = 0; bookmark_it < _tmp4__length1; bookmark_it = bookmark_it + 1) {
#line 522 "bookmarks.c"
			gchar* _tmp5_ = NULL;
			gchar* bookmark = NULL;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp5_ = g_strdup (bookmark_collection[bookmark_it]);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			bookmark = _tmp5_;
#line 529 "bookmarks.c"
			{
				Block9Data* _data9_;
				const gchar* _tmp6_ = NULL;
				Bookmark* _tmp7_ = NULL;
				Bookmark* _tmp8_ = NULL;
				GtkButton* _tmp9_ = NULL;
				gulong _tmp10_ = 0UL;
				Bookmark* _tmp11_ = NULL;
				GtkButton* _tmp12_ = NULL;
				Bookmark* _tmp13_ = NULL;
				GtkListBox* _tmp14_ = NULL;
				Bookmark* _tmp15_ = NULL;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_ = g_slice_new0 (Block9Data);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_->_ref_count_ = 1;
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_->self = g_object_ref (self);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_->bookmark = bookmark;
#line 91 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp6_ = _data9_->bookmark;
#line 91 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp7_ = bookmark_new (_tmp6_);
#line 91 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				g_object_ref_sink (_tmp7_);
#line 91 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_->bookmark_row = _tmp7_;
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp8_ = _data9_->bookmark_row;
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp9_ = _tmp8_->destroy_button;
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp10_ = g_signal_connect_data (_tmp9_, "clicked", (GCallback) _____lambda6__gtk_button_clicked, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 92 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_->destroy_button_clicked_handler = _tmp10_;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp11_ = _data9_->bookmark_row;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp12_ = _tmp11_->destroy_button;
#line 93 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				g_signal_connect_data ((GtkWidget*) _tmp12_, "destroy", (GCallback) _____lambda7__gtk_widget_destroy, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 94 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp13_ = _data9_->bookmark_row;
#line 94 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				gtk_widget_show ((GtkWidget*) _tmp13_);
#line 95 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp14_ = self->priv->bookmarks_list_box;
#line 95 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp15_ = _data9_->bookmark_row;
#line 95 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				block9_data_unref (_data9_);
#line 89 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_data9_ = NULL;
#line 586 "bookmarks.c"
			}
		}
	}
#line 84 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks = (_vala_array_free (bookmarks, bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 592 "bookmarks.c"
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if ((*length) == (*size)) {
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 603 "bookmarks.c"
	}
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	(*array)[(*length)++] = value;
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	(*array)[*length] = NULL;
#line 609 "bookmarks.c"
}


static void bookmarks_switch_changed_cb (Bookmarks* self) {
	GtkPopover* _tmp0_ = NULL;
	gchar** bookmarks = NULL;
	GSettings* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint bookmarks_length1 = 0;
	gint _bookmarks_size_ = 0;
	GtkSwitch* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 99 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 101 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_popover;
#line 101 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_emit_by_name (_tmp0_, "closed");
#line 103 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 103 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 103 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks = _tmp3_;
#line 103 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_length1 = _vala_array_length (_tmp2_);
#line 103 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_bookmarks_size_ = bookmarks_length1;
#line 105 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = self->priv->bookmarked_switch;
#line 105 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5_ = gtk_switch_get_active (_tmp4_);
#line 105 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (!_tmp5_) {
#line 645 "bookmarks.c"
		const gchar* _tmp6_ = NULL;
#line 106 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp6_ = self->priv->current_path;
#line 106 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmarks_remove_bookmark (self, _tmp6_);
#line 651 "bookmarks.c"
	} else {
		const gchar* _tmp7_ = NULL;
		gchar** _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
#line 107 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp7_ = self->priv->current_path;
#line 107 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp8_ = bookmarks;
#line 107 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp8__length1 = bookmarks_length1;
#line 107 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		if (!_vala_string_array_contains (_tmp8_, _tmp8__length1, _tmp7_)) {
#line 664 "bookmarks.c"
			gchar** _tmp9_ = NULL;
			gint _tmp9__length1 = 0;
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			GSettings* _tmp12_ = NULL;
			gchar** _tmp13_ = NULL;
			gint _tmp13__length1 = 0;
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp9_ = bookmarks;
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp9__length1 = bookmarks_length1;
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp10_ = self->priv->current_path;
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 109 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_vala_array_add1 (&bookmarks, &bookmarks_length1, &_bookmarks_size_, _tmp11_);
#line 110 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp12_ = self->priv->settings;
#line 110 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp13_ = bookmarks;
#line 110 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp13__length1 = bookmarks_length1;
#line 110 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			g_settings_set_strv (_tmp12_, "bookmarks", _tmp13_);
#line 690 "bookmarks.c"
		}
	}
#line 99 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks = (_vala_array_free (bookmarks, bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 695 "bookmarks.c"
}


void bookmarks_set_bookmarked (Bookmarks* self, gboolean new_state) {
	GtkSwitch* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 114 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 116 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarked_switch;
#line 116 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 116 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp2_ = new_state;
#line 116 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (_tmp1_ != _tmp2_) {
#line 713 "bookmarks.c"
		GtkSwitch* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
#line 117 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp3_ = self->priv->bookmarked_switch;
#line 117 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_tmp4_ = new_state;
#line 117 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		gtk_switch_set_active (_tmp3_, _tmp4_);
#line 722 "bookmarks.c"
	}
}


static void bookmarks_bookmark_activated_cb (Bookmarks* self, GtkListBoxRow* list_box_row) {
	GtkPopover* _tmp0_ = NULL;
	gchar* bookmark = NULL;
	GtkListBoxRow* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 121 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 121 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (list_box_row != NULL);
#line 123 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_popover;
#line 123 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_emit_by_name (_tmp0_, "closed");
#line 124 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = list_box_row;
#line 124 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) _tmp1_);
#line 124 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = bookmark_get_bookmark_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_BOOKMARK, Bookmark));
#line 124 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = _tmp3_;
#line 124 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 124 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmark = _tmp5_;
#line 125 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_emit_by_name ((PathElement*) self, "request-path", bookmark);
#line 121 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_free0 (bookmark);
#line 759 "bookmarks.c"
}


static void _bookmarks_bookmark_activated_cb_gtk_list_box_row_activated (GtkListBox* _sender, GtkListBoxRow* row, gpointer self) {
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_bookmark_activated_cb ((Bookmarks*) self, row);
#line 766 "bookmarks.c"
}


static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if ((*length) == (*size)) {
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 777 "bookmarks.c"
	}
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	(*array)[(*length)++] = value;
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	(*array)[*length] = NULL;
#line 783 "bookmarks.c"
}


static void bookmarks_remove_bookmark (Bookmarks* self, const gchar* bookmark_name) {
	GtkPopover* _tmp0_ = NULL;
	gchar** old_bookmarks = NULL;
	GSettings* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint old_bookmarks_length1 = 0;
	gint _old_bookmarks_size_ = 0;
	const gchar* _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gchar** new_bookmarks = NULL;
	gchar** _tmp6_ = NULL;
	gint new_bookmarks_length1 = 0;
	gint _new_bookmarks_size_ = 0;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	GSettings* _tmp14_ = NULL;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
#line 128 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 128 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (bookmark_name != NULL);
#line 130 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarks_popover;
#line 130 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_emit_by_name (_tmp0_, "closed");
#line 131 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = self->priv->settings;
#line 131 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
#line 131 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	old_bookmarks = _tmp3_;
#line 131 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	old_bookmarks_length1 = _vala_array_length (_tmp2_);
#line 131 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_old_bookmarks_size_ = old_bookmarks_length1;
#line 132 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = bookmark_name;
#line 132 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5_ = old_bookmarks;
#line 132 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5__length1 = old_bookmarks_length1;
#line 132 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (!_vala_string_array_contains (_tmp5_, _tmp5__length1, _tmp4_)) {
#line 133 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		old_bookmarks = (_vala_array_free (old_bookmarks, old_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 133 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		return;
#line 837 "bookmarks.c"
	}
#line 134 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 134 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	new_bookmarks = _tmp6_;
#line 134 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	new_bookmarks_length1 = 0;
#line 134 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_new_bookmarks_size_ = new_bookmarks_length1;
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp7_ = old_bookmarks;
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp7__length1 = old_bookmarks_length1;
#line 851 "bookmarks.c"
	{
		gchar** bookmark_collection = NULL;
		gint bookmark_collection_length1 = 0;
		gint _bookmark_collection_size_ = 0;
		gint bookmark_it = 0;
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmark_collection = _tmp7_;
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmark_collection_length1 = _tmp7__length1;
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		for (bookmark_it = 0; bookmark_it < _tmp7__length1; bookmark_it = bookmark_it + 1) {
#line 863 "bookmarks.c"
			gchar* _tmp8_ = NULL;
			gchar* bookmark = NULL;
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			_tmp8_ = g_strdup (bookmark_collection[bookmark_it]);
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
			bookmark = _tmp8_;
#line 870 "bookmarks.c"
			{
				const gchar* _tmp9_ = NULL;
				const gchar* _tmp10_ = NULL;
#line 136 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp9_ = bookmark;
#line 136 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_tmp10_ = bookmark_name;
#line 136 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				if (g_strcmp0 (_tmp9_, _tmp10_) != 0) {
#line 880 "bookmarks.c"
					gchar** _tmp11_ = NULL;
					gint _tmp11__length1 = 0;
					const gchar* _tmp12_ = NULL;
					gchar* _tmp13_ = NULL;
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
					_tmp11_ = new_bookmarks;
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
					_tmp11__length1 = new_bookmarks_length1;
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
					_tmp12_ = bookmark;
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
					_tmp13_ = g_strdup (_tmp12_);
#line 137 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
					_vala_array_add2 (&new_bookmarks, &new_bookmarks_length1, &_new_bookmarks_size_, _tmp13_);
#line 895 "bookmarks.c"
				}
#line 135 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
				_g_free0 (bookmark);
#line 899 "bookmarks.c"
			}
		}
	}
#line 138 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp14_ = self->priv->settings;
#line 138 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp15_ = new_bookmarks;
#line 138 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp15__length1 = new_bookmarks_length1;
#line 138 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_settings_set_strv (_tmp14_, "bookmarks", _tmp15_);
#line 128 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	new_bookmarks = (_vala_array_free (new_bookmarks, new_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 128 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	old_bookmarks = (_vala_array_free (old_bookmarks, old_bookmarks_length1, (GDestroyNotify) g_free), NULL);
#line 915 "bookmarks.c"
}


Bookmarks* bookmarks_construct (GType object_type) {
	Bookmarks * self = NULL;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = (Bookmarks*) g_object_new (object_type, NULL);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return self;
#line 925 "bookmarks.c"
}


Bookmarks* bookmarks_new (void) {
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return bookmarks_construct (TYPE_BOOKMARKS);
#line 932 "bookmarks.c"
}


const gchar* bookmarks_get_schema_id (Bookmarks* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->_schema_id;
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	result = _tmp0_;
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return result;
#line 947 "bookmarks.c"
}


static void bookmarks_set_schema_id (Bookmarks* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = value;
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_free0 (self->priv->_schema_id);
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv->_schema_id = _tmp1_;
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_object_notify ((GObject *) self, "schema-id");
#line 966 "bookmarks.c"
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return _data10_;
#line 975 "bookmarks.c"
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 984 "bookmarks.c"
		Bookmarks* self;
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		self = _data10_->self;
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		_g_object_unref0 (self);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		g_slice_free (Block10Data, _data10_);
#line 992 "bookmarks.c"
	}
}


static void _bookmarks_switch_changed_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 46 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_switch_changed_cb ((Bookmarks*) self);
#line 1000 "bookmarks.c"
}


static void _bookmarks___lambda8_ (Bookmarks* self) {
#line 48 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_update_bookmarks (self);
#line 49 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_update_icon_and_switch (self);
#line 1009 "bookmarks.c"
}


static void __bookmarks___lambda8__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
#line 47 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_bookmarks___lambda8_ ((Bookmarks*) self);
#line 1016 "bookmarks.c"
}


static void _bookmarks___lambda9_ (Block10Data* _data10_) {
	Bookmarks* self;
	GSettings* _tmp0_ = NULL;
	gulong _tmp1_ = 0UL;
#line 55 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = _data10_->self;
#line 55 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->settings;
#line 55 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = _data10_->bookmarks_changed_handler;
#line 55 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
#line 1032 "bookmarks.c"
}


static void __bookmarks___lambda9__gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
#line 55 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_bookmarks___lambda9_ (self);
#line 1039 "bookmarks.c"
}


static void _bookmarks___lambda10_ (Bookmarks* self) {
	GtkSwitch* _tmp0_ = NULL;
	gulong _tmp1_ = 0UL;
#line 56 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmarked_switch;
#line 56 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = self->priv->switch_active_handler;
#line 56 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
#line 1052 "bookmarks.c"
}


static void __bookmarks___lambda10__gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
#line 56 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_bookmarks___lambda10_ ((Bookmarks*) self);
#line 1059 "bookmarks.c"
}


static GObject * bookmarks_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Bookmarks * self;
	Block10Data* _data10_;
	const gchar* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	GtkSwitch* _tmp2_ = NULL;
	gulong _tmp3_ = 0UL;
	GSettings* _tmp4_ = NULL;
	gulong _tmp5_ = 0UL;
	GtkSwitch* _tmp6_ = NULL;
	GtkSwitch* _tmp7_ = NULL;
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	parent_class = G_OBJECT_CLASS (bookmarks_parent_class);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARKS, Bookmarks);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_data10_->_ref_count_ = 1;
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_data10_->self = g_object_ref (self);
#line 44 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->_schema_id;
#line 44 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = g_settings_new (_tmp0_);
#line 44 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->settings);
#line 44 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv->settings = _tmp1_;
#line 46 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp2_ = self->priv->bookmarked_switch;
#line 46 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp3_ = g_signal_connect_object ((GObject*) _tmp2_, "notify::active", (GCallback) _bookmarks_switch_changed_cb_g_object_notify, self, 0);
#line 46 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv->switch_active_handler = _tmp3_;
#line 47 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp4_ = self->priv->settings;
#line 47 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "changed::bookmarks", (GCallback) __bookmarks___lambda8__g_settings_changed, self, 0);
#line 47 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_data10_->bookmarks_changed_handler = _tmp5_;
#line 52 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_update_bookmarks (self);
#line 53 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp6_ = self->priv->bookmarked_switch;
#line 53 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 55 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_connect_data ((GtkWidget*) self, "destroy", (GCallback) __bookmarks___lambda9__gtk_widget_destroy, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 56 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp7_ = self->priv->bookmarked_switch;
#line 56 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_signal_connect_object ((GtkWidget*) _tmp7_, "destroy", (GCallback) __bookmarks___lambda10__gtk_widget_destroy, self, 0);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	block10_data_unref (_data10_);
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_data10_ = NULL;
#line 42 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return obj;
#line 1126 "bookmarks.c"
}


static void bookmarks_class_init (BookmarksClass * klass) {
	gint Bookmarks_private_offset;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_parent_class = g_type_class_peek_parent (klass);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_type_class_add_private (klass, sizeof (BookmarksPrivate));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bookmarks_get_property;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bookmarks_set_property;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->constructor = bookmarks_constructor;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->finalize = bookmarks_finalize;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOKMARKS_SCHEMA_ID, g_param_spec_string ("schema-id", "schema-id", "schema-id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	Bookmarks_private_offset = g_type_class_get_instance_private_offset (klass);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/bookmarks.ui");
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_list_box", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_list_box));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_popover", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_popover));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_icon", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_icon));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarked_switch", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarked_switch));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "bookmark_activated_cb", G_CALLBACK(_bookmarks_bookmark_activated_cb_gtk_list_box_row_activated));
#line 1160 "bookmarks.c"
}


static void bookmarks_path_element_interface_init (PathElementIface * iface) {
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmarks_path_element_parent_iface = g_type_interface_peek_parent (iface);
#line 1167 "bookmarks.c"
}


static void bookmarks_instance_init (Bookmarks * self) {
	gchar* _tmp0_ = NULL;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv = BOOKMARKS_GET_PRIVATE (self);
#line 29 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = g_strdup ("/");
#line 29 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv->current_path = _tmp0_;
#line 40 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv->switch_active_handler = (gulong) 0;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1183 "bookmarks.c"
}


static void bookmarks_finalize (GObject* obj) {
	Bookmarks * self;
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARKS, Bookmarks);
#line 23 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarks_list_box);
#line 24 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarks_popover);
#line 26 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarks_icon);
#line 27 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmarked_switch);
#line 29 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_free0 (self->priv->current_path);
#line 37 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_free0 (self->priv->_schema_id);
#line 38 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->settings);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (bookmarks_parent_class)->finalize (obj);
#line 1207 "bookmarks.c"
}


GType bookmarks_get_type (void) {
	static volatile gsize bookmarks_type_id__volatile = 0;
	if (g_once_init_enter (&bookmarks_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookmarksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookmarks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bookmarks), 0, (GInstanceInitFunc) bookmarks_instance_init, NULL };
		static const GInterfaceInfo path_element_info = { (GInterfaceInitFunc) bookmarks_path_element_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType bookmarks_type_id;
		bookmarks_type_id = g_type_register_static (gtk_menu_button_get_type (), "Bookmarks", &g_define_type_info, 0);
		g_type_add_interface_static (bookmarks_type_id, TYPE_PATH_ELEMENT, &path_element_info);
		g_once_init_leave (&bookmarks_type_id__volatile, bookmarks_type_id);
	}
	return bookmarks_type_id__volatile;
}


static void _vala_bookmarks_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARKS, Bookmarks);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	switch (property_id) {
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		case BOOKMARKS_SCHEMA_ID:
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		g_value_set_string (value, bookmarks_get_schema_id (self));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1236 "bookmarks.c"
		default:
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1242 "bookmarks.c"
	}
}


static void _vala_bookmarks_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARKS, Bookmarks);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	switch (property_id) {
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		case BOOKMARKS_SCHEMA_ID:
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmarks_set_schema_id (self, g_value_get_string (value));
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1258 "bookmarks.c"
		default:
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1264 "bookmarks.c"
	}
}


Bookmark* bookmark_construct (GType object_type, const gchar* bookmark_name) {
	Bookmark * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 155 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_val_if_fail (bookmark_name != NULL, NULL);
#line 157 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = bookmark_name;
#line 157 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = (Bookmark*) g_object_new (object_type, "bookmark-name", _tmp0_, NULL);
#line 155 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return self;
#line 1280 "bookmarks.c"
}


Bookmark* bookmark_new (const gchar* bookmark_name) {
#line 155 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return bookmark_construct (TYPE_BOOKMARK, bookmark_name);
#line 1287 "bookmarks.c"
}


const gchar* bookmark_get_bookmark_name (Bookmark* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->_bookmark_name;
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	result = _tmp0_;
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return result;
#line 1302 "bookmarks.c"
}


static void bookmark_set_bookmark_name (Bookmark* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_return_if_fail (self != NULL);
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = value;
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_free0 (self->priv->_bookmark_name);
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv->_bookmark_name = _tmp1_;
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_object_notify ((GObject *) self, "bookmark-name");
#line 1321 "bookmarks.c"
}


static GObject * bookmark_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Bookmark * self;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 150 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	parent_class = G_OBJECT_CLASS (bookmark_parent_class);
#line 150 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 150 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARK, Bookmark);
#line 152 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp0_ = self->priv->bookmark_label;
#line 152 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_tmp1_ = self->priv->_bookmark_name;
#line 152 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 150 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	return obj;
#line 1345 "bookmarks.c"
}


static void bookmark_class_init (BookmarkClass * klass) {
	gint Bookmark_private_offset;
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	bookmark_parent_class = g_type_class_peek_parent (klass);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_type_class_add_private (klass, sizeof (BookmarkPrivate));
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bookmark_get_property;
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bookmark_set_property;
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->constructor = bookmark_constructor;
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (klass)->finalize = bookmark_finalize;
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOKMARK_BOOKMARK_NAME, g_param_spec_string ("bookmark-name", "bookmark-name", "bookmark-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	Bookmark_private_offset = g_type_class_get_instance_private_offset (klass);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/bookmark.ui");
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmark_label", FALSE, Bookmark_private_offset + G_STRUCT_OFFSET (BookmarkPrivate, bookmark_label));
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "destroy_button", FALSE, G_STRUCT_OFFSET (Bookmark, destroy_button));
#line 1373 "bookmarks.c"
}


static void bookmark_instance_init (Bookmark * self) {
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self->priv = BOOKMARK_GET_PRIVATE (self);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1382 "bookmarks.c"
}


static void bookmark_finalize (GObject* obj) {
	Bookmark * self;
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARK, Bookmark);
#line 145 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_free0 (self->priv->_bookmark_name);
#line 147 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->priv->bookmark_label);
#line 148 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	_g_object_unref0 (self->destroy_button);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	G_OBJECT_CLASS (bookmark_parent_class)->finalize (obj);
#line 1398 "bookmarks.c"
}


GType bookmark_get_type (void) {
	static volatile gsize bookmark_type_id__volatile = 0;
	if (g_once_init_enter (&bookmark_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookmarkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookmark_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bookmark), 0, (GInstanceInitFunc) bookmark_instance_init, NULL };
		GType bookmark_type_id;
		bookmark_type_id = g_type_register_static (gtk_grid_get_type (), "Bookmark", &g_define_type_info, 0);
		g_once_init_leave (&bookmark_type_id__volatile, bookmark_type_id);
	}
	return bookmark_type_id__volatile;
}


static void _vala_bookmark_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Bookmark * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARK, Bookmark);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	switch (property_id) {
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		case BOOKMARK_BOOKMARK_NAME:
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		g_value_set_string (value, bookmark_get_bookmark_name (self));
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1425 "bookmarks.c"
		default:
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1431 "bookmarks.c"
	}
}


static void _vala_bookmark_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Bookmark * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARK, Bookmark);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
	switch (property_id) {
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		case BOOKMARK_BOOKMARK_NAME:
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		bookmark_set_bookmark_name (self, g_value_get_string (value));
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1447 "bookmarks.c"
		default:
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 143 "/run/media/triton/Guerre/jhbuild/jhbuild/dconf-editor/editor/bookmarks.vala"
		break;
#line 1453 "bookmarks.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



